import { Provider } from '@angular/core';
import { ControlValueAccessor } from '@angular/common';
export interface IProviderConfig {
    useClass?: any;
    useValue?: any;
    useExisting?: any;
    useFactory?: any;
    deps?: any[];
    multi?: boolean;
}
export declare function makeValueAccessorProvider(config: IProviderConfig): Provider;
export declare abstract class ValueAccessor<T> implements ControlValueAccessor {
    onChange: (_: any) => void;
    onTouched: () => void;
    abstract writeValue(value: T): void;
    triggerChange(value: T): void;
    registerOnChange(fn: (_: T) => void): void;
    registerOnTouched(fn: () => void): void;
}
