import { AfterViewInit, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { services } from 'typescript-angular-utilities';
import __object = services.object;
import __array = services.array;
import __guid = services.guid;
import __transform = services.transform;
import { ValidatedInputComponent } from '../input/validationInput';
import { ComponentValidator } from '../../services/componentValidator/componentValidator.service';
import { FormComponent } from '../form/form';
import { BusyComponent } from '../busy/busy';
export declare class SelectComponent<T> extends ValidatedInputComponent<T> implements AfterViewInit {
    options: T[] | Observable<T[]>;
    transform: __transform.ITransform<T, string>;
    nullOption: string;
    busy: BusyComponent;
    template: TemplateRef<any>;
    wrappedOptions: Observable<T[]>;
    showOptions: boolean;
    private transformService;
    constructor(transformService: __transform.ITransformService, rlForm: FormComponent, componentValidator: ComponentValidator, object: __object.IObjectUtility, array: __array.IArrayUtility, guid: __guid.IGuidService);
    ngAfterViewInit(): void;
    toggle(): void;
    close: {
        (): void;
    };
    select(value: T): void;
    getDisplayName(item: T): string;
    newTemplate(): TemplateRef<any>;
}
