import { AfterViewInit, OnChanges, AfterViewChecked, ElementRef, SimpleChange } from '@angular/core';
import '../../../libraries/bootstrap-touchspin/index';
import { services } from 'typescript-angular-utilities';
import __object = services.object;
import __array = services.array;
import __guid = services.guid;
import __number = services.number;
import __string = services.string;
import { ValidatedInputComponent, IInputChanges } from '../input/validationInput';
import { ComponentValidator } from '../../services/componentValidator/componentValidator.service';
import { FormComponent } from '../form/form';
export declare const defaultMaxValue: number;
export interface ISpinnerChanges extends IInputChanges {
    disabled: SimpleChange;
}
export declare class SpinnerComponent extends ValidatedInputComponent<number> implements AfterViewInit, OnChanges, AfterViewChecked {
    min: number;
    max: number;
    step: number;
    decimals: number;
    prefix: string;
    postfix: string;
    roundToStep: boolean;
    spinnerId: string;
    spinner: ElementRef;
    private number;
    private string;
    private rendering;
    private touchspin;
    constructor(number: __number.INumberUtility, string: __string.IStringUtility, rlForm: FormComponent, componentValidator: ComponentValidator, object: __object.IObjectUtility, array: __array.IArrayUtility, guid: __guid.IGuidService);
    ngAfterViewInit(): void;
    ngOnChanges(changes: ISpinnerChanges): void;
    ngAfterViewChecked(): void;
    private round(num);
    private setDisabled(disabled);
}
